<template>
  <div>
    <Modal v-model="showModal" :mask-closable="false" width="900">
      <p slot="header">{{modalTitle}}</p>
      <div>
        <Form id="MeterSendTestEdit" ref="formObj" :model="formObj" :label-width="90" inline>
          <Form-item @click.native="_selectReceiverPerson" label="接收人" prop="receiver" class="width-48">
            <Input v-model="formObj.receiver" name="receiver" placeholder="请输入接收人"/>
          </Form-item>
          <Form-item label="接收日期：" prop="receiveTime" class="width-48">
            <Date-picker v-model="formObj.receiveTime" @on-change="_ctimeChange" type="date" split-panels style="width:100%;"
                         placeholder="请选择接收日期" name="receiveTime"></Date-picker>
          </Form-item>
          <Form-item label="项目名称" prop="projectName" class="width-48">
            <AutoComplete ref="autoInput" v-model="formObj.projectName" :down-data="projectData"
                          @on-result-change="_projectChange" name="projectName" placeholder="请输入或选择项目名称"
            ></AutoComplete>
          </Form-item>
          <Form-item label="项目负责人" prop="projectLeader" class="width-48">
            <AutoComplete ref="autoInput" v-model="formObj.projectLeader" :down-data="projectLeaderData"
                          @on-result-change="_projectLeaderChange" show-key="realname" name="projectLeader" placeholder="请输入或选择项目负责人"
            ></AutoComplete>
<!--            <Input v-model="formObj.projectLeader"  name="projectLeader" placeholder="请输入项目负责人"/>-->
          </Form-item>
          <Form-item label="钻孔名称" prop="boreholeName" class="width-48">
            <Input v-model="formObj.boreholeName" name="boreholeName" placeholder="请输入名称"/>
          </Form-item>
          <Form-item label="箱数" prop="casesNum" class="width-48">
            <Input v-model="formObj.casesNum" name="casesNum" placeholder="请输入箱数"/>
          </Form-item>
          <Form-item @click.native="_selectRegisterPerson" label="登记人" prop="registrant" class="width-48">
            <Input v-model="formObj.registrant" name="registrant" placeholder="请输入登记人"/>
          </Form-item>
          <Form-item label="登记日期：" prop="registTime" class="width-48">
            <Date-picker v-model="formObj.registTime" @on-change="_tabulateChange" name="registTime" type="date" split-panels style="width:100%;"
                         placeholder="请选择登记日期"></Date-picker>
          </Form-item>
        </Form>
      </div>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult"></modal-footer>
      </div>
    </Modal>
    <importModal ref="importModal" @on-result-change="_inputBack"   aptitude-item></importModal>
    <SampleItemSelect ref="sampleItemSelectModal" @on-result-change="_itemImportBack" is-change />
    <assignPerson ref="userModal" @on-result-change="_userResult"></assignPerson>
    <SampleItemRemove ref="sampleItemRemove" @on-result-change = '_removeItemBack'></SampleItemRemove>
    <SampleItemEdit ref="sampleItemEdit" @on-result-change = '_removeItemBack'></SampleItemEdit>
  </div>
</template>
<script>
/**
 * 添加编辑分包商
 */
import { meterEntrust, meterSample, soilEntrust, soilSample } from '../../api'
import importModal from '../../components/import/DownloadTemplateImport'
import AutoComplete from '../../components/base/AutoCompletes'
import SampleItemSelect from '../meter-aptitude/standard-manage/SampleItemSelect'
import assignPerson from '../../components/user-info-single/assignPerson'
import Global from '../../api/config'
import SampleItemRemove from './SampleItemRemove'
import SampleItemEdit from './SampleItemEdit'
export default {
  components: {
    AutoComplete,
    importModal,
    SampleItemSelect,
    assignPerson,
    SampleItemRemove,
    SampleItemEdit
  },
  data() {
    return {
      formId: 'meterSendTestEditFormId',
      getPage: {
        records: []
      },
      showBtn: true,
      customerData: [],
      projectData: [],
      projectLeaderData: [],
      edit: false,
      cityData: [],
      selectData: [],
      sampleItemList: [],
      searchOpen: true,
      testedCityData: [],
      judgeType: [{ value: 1, name: '是' }, { value: 0, name: '否' }],
      iconMsg: [
        {
          type: 'md-trash',
          id: '',
          name: '删除'
        }
      ],
      pageColumns: [
        { title: '试样编号', key: 'sampleCode', width: 140 },
        { title: '现场编号', key: 'siteNo', width: 140 },
        { title: '试验项目', key: 'experiments', width: 140 },
        { title: '试样深度', key: 'sampleDepth', width: 140 },
        { title: '样品包装类型', key: 'samplePack', width: 150 },
        { title: '土质描述', key: 'sampleDescribe' }
      ],
      btn: [
        {
          type: 'success',
          id: '',
          name: '添加'
        },
        {
          type: 'success',
          id: '',
          name: '导入试验项目'
        }
      ],
      btnEdit: [
        {
          type: 'success',
          id: '',
          name: '添加'
        },
        {
          type: 'success',
          id: '',
          name: '导入试验项目'
        }
      ],
      options: [
        {
          name: '检定'
        },
        {
          name: '校准'
        },
        {
          name: '外观检查'
        }
      ],
      typeoptions: [],
      personType: '',
      packList: [],
      soilList: [],
      projectLeaderName: [],
      currentIndex: -1,
      id: '',
      modalTitle: '',
      subcontractorId: '',
      formObj: {},
      selectIds: [],
      indexList: [],
      itemList: [],
      clearingWayList: ['款到后测试', '先测试后付款', '其他情况（）'],
      clearingWayListTemp: ['款到后测试', '先测试后付款', '其他情况（）'],
      showModal: false,
      footerList: [
        { id: '', name: '取消', type: '' },
        { id: '', name: '保存', type: 'primary' }
      ],
      aptitudeData: []
    }
  },
  methods: {
    typeChange(data) {
      this.$forceUpdate()
      this.formObj.testType = data
    },
    _removeItem(itemInfo) {
      console.log('试验项目', itemInfo)
      this.sampleItemList = itemInfo.experimentList
      if (itemInfo.sampleCode !== '') {
        this.$refs.sampleItemEdit._open(this.sampleItemList)
      } else {
        this.$refs.sampleItemRemove._open(this.sampleItemList)
      }
    },
    _removeItemBack(data) {
      this.$forceUpdate()
      if (data) {
        this.getPage.records[this.currentIndex].experimentList = data
        const itemNames = []
        for (let j = 0; j < data.length; j++) {
          itemNames.push(data[j].name)
        }
        this.getPage.records[this.currentIndex].experiments = itemNames.join(
          ','
        )
      }
      this.$set(
        this.getPage.records,
        this.currentIndex,
        this.getPage.records[this.currentIndex]
      )
    },
    _itemImportBack(data) {
      this.$forceUpdate()
      for (let i = 0; i < data.length; i++) {
        data[i].id = undefined
      }
      const info = data
      for (let i = 0; i < this.indexList.length; i++) {
        const index = this.indexList[i]
        if (
          this.getPage.records[index].experimentList !== undefined &&
          this.getPage.records[index].experimentList !== []
        ) {
          const name = []
          this.itemList = this.getPage.records[index].experimentList
          name.push(this.getPage.records[index].experiments)
          for (let i = 0; i < info.length; i++) {
            this.itemList.push(info[i])
            name.push(info[i].name)
          }
          this.getPage.records[index].experiments = name.join('、')
          this.getPage.records[index].experimentList = this.itemList
          this.$set(this.getPage.records, index, this.getPage.records[index])
        } else {
          const name = []
          this.itemList = []
          for (let i = 0; i < info.length; i++) {
            this.itemList.push(info[i])
            name.push(info[i].name)
          }
          this.getPage.records[index].experiments = name.join('、')
          this.getPage.records[index].experimentList = this.itemList
          this.$set(this.getPage.records, index, this.getPage.records[index])
        }
      }
    },
    _selectProjectPerson() {
      this.personType = 'project'
      this.$refs.userModal._openOrg('选择人员', 'itemTree')
    },
    _selectReceiverPerson() {
      this.personType = 'receive'
      this.$refs.userModal._openOrg('选择人员', 'itemTree')
    },
    _selectRegisterPerson() {
      this.personType = 'resistrant'
      this.$refs.userModal._openOrg('选择人员', 'itemTree')
    },
    _userResult(data, msg) {
      console.log(msg)
      this.$forceUpdate()
      if (this.personType === 'resistrant') {
        this.formObj.registrant = data.realname
        this.formObj.registrantId = data.id
      } else if (this.personType === 'receive') {
        this.formObj.receiver = data.realname
      } else {
        this.formObj.projectLeader = data.realname
        this.formObj.projectLeaderId = data.id
      }
    },
    _packChange(msg, data) {
      switch (msg) {
        case 'select':
          this.getPage.records[this.currentIndex].samplePack = data
          break
        case 'query':
          this.getPage.records[this.currentIndex].samplePack = data
          break
      }
    },
    _soilChange(msg, data) {
      switch (msg) {
        case 'select':
          this.getPage.records[this.currentIndex].sampleDescribe = data
          break
        case 'query':
          this.getPage.records[this.currentIndex].sampleDescribe = data
          break
      }
    },
    _cusNameChange(msg, data) {
      if (this.$string(this.id).isEmpty()) {
        // 添加的时候选择单位
        switch (msg) {
          case 'select':
            this._customerMatch(data)
            break
          case 'query':
            this._cusNameQuery(data)
            break
        }
      } else if (this.customerData.indexOf(data) !== -1) {
        this._getQueryList(data)
      } else {
        this._cusNameQuery(data)
      }
    },
    _customerMatch(data) {
      this._getQueryList(data)
    },
    _cusNameQuery(query) {
      console.log('query', query)
      this.formObj.client = query
      this._getQueryList(query)
    },
    _projectChange(msg, data) {
      if (this.$string(this.id).isEmpty()) {
        // 添加的时候选择单位
        switch (msg) {
          case 'select':
            this._projectMatch(data)
            break
          case 'query':
            this._projectQuery(data)
            break
        }
      } else if (this.projectData.indexOf(data) !== -1) {
        this._getProjectQueryList(data)
      } else {
        this._projectQuery(data)
      }
    },
    _projectLeaderChange(msg, data) {
      // 添加的时候选择单位
      console.log(msg, data)
      switch (msg) {
        case 'select':
          this._leaderMatch(data)
          break
        case 'query':
          this._leaderQuery(data)
          break
      }
    },
    _leaderMatch(data) {
      console.log('选中', data)
      this.formObj.projectLeader = data.realname
      if (data.id) {
        this.formObj.projectLeaderId = data.id
      }
    },
    _leaderQuery(query) {
      this.formObj.projectLeader = query.realname
      this._queryUserList(query)
    },
    _projectMatch(data) {
      this.formObj.projectName = data
    },
    _projectQuery(query) {
      this.formObj.projectName = query
      this._getProjectQueryList(query)
    },
    _btnClick(msg) {
      this.$nextTick(function() {
        switch (msg) {
          case '添加':
            this._add()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _getByEntrustId: async function(id) {
      const result = await soilEntrust.getVOById(id)
      if (result) {
        this.$forceUpdate()
        const sampleList = Object.assign(
          this.getPage.records,
          result.sampleList
        )
        this.$set(this.getPage.records, sampleList)
      }
    },
    _inputBack(data) {
      if (data) {
        this._getByEntrustId(this.id)
      }
    },
    _ctimeChange(data) {
      this.formObj.receiveTime = data
    },
    _tabulateChange(data) {
      this.formObj.registTime = data
    },
    _odateChange(data) {
      this.formObj.odate = data
    },
    _judgeBasisChange(msg, data) {
      switch (msg) {
        case 'select':
          this.formObj.stdId = data.id
          this.formObj.code = data.stdNum
          this.formObj.name = data.name
          this.$refs.formObj.validateField('code')
          break
        case 'query':
          this.formObj.stdId = ''
          this.formObj.code = data.stdNum
          this.formObj.name = ''
          this._getJudgeBasisList(data.stdNum)
          break
        case 'focus':
          this._getJudgeBasisList()
          break
        case 'blur':
          if (this.formObj.stdId === '') {
            this.formObj.code = ''
            this._getJudgeBasisList()
          }
          this.$refs.formObj.validateField('code')
      }
    },
    _selectjudgeBasis(index) {
      this.index = index
      this.$refs.EditModal._open()
    },
    _selectverification(index) {
      this.index = index
      this.$refs.VerificationModal._open()
    },
    _selectcontractCode() {
      this.$refs.ContractModal._open()
    },
    _backData(data) {
      this.$forceUpdate()
      console.log(typeof this.index)
      this.getPage.records[this.index].name = data.name
      this.getPage.records[this.index].aptitudeId = data.id
      this.getPage.records[this.index].verification = data.code + data.basis
      this.getPage.records[this.index].price = data.price
      this.getPage.records[this.index].totalPrice =
        data.price * this.getPage.records[this.index].quantity
    },
    _backContract(data) {
      this.formObj.client = data.client
      this.formObj.operation.person = data.person
      this.formObj.operation.tel = data.tel
      this.formObj.operation.fax = data.fax
      if (data.province) {
        this.testedCityData = [data.province, data.city, data.county]
        this.formObj.province = data.province
        this.formObj.city = data.city
        this.formObj.county = data.county
      }
      this.formObj.street = data.street
      this.formObj.entrustDate = new Date(data.entrustDate)
      this.formObj.odate = new Date(data.odate)
      this.formObj.contractCode = data.salesCode
      this.formObj.operation.fee = data.discountPrice
      if (data.sampleQuoteList) {
        this.getPage.records = data.sampleQuoteList
      } else {
        this.getPage.records = []
      }
    },
    _backVerification(data) {
      this.$forceUpdate()
      this.getPage.records[this.index].verification = data.verification
    },
    _add() {
      const data = {
        sampleCode: '',
        sampleDepth: '',
        samplePack: '',
        sampleDescribe: '',
        siteNo: '',
        experiments: ''
      }
      this.getPage.records.push(data)
    },
    _getPackList: async function() {
      const result = await soilEntrust.testType('样品包装类型')
      if (result) {
        const pack = []
        for (let i = 0; i < result.length; i++) {
          pack.push(result[i].name)
        }
        this.packList = pack
      }
    },
    _getSoil: async function() {
      const result = await soilEntrust.testType('土质描述')
      if (result) {
        const soilRemark = []
        for (let i = 0; i < result.length; i++) {
          soilRemark.push(result[i].name)
        }
        this.soilList = soilRemark
      }
    },
    _tableResultChange(msg, data, selData) {
      switch (msg) {
        case 'selectIds':
          this.selectIds = data
          this.selectData = selData
          console.log(this.selectIds)
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.rowIndex)
          break
      }
    },
    allSelect(data) {
      console.log(data)
      this.indexList = []
      for (let i = 0; i < data.length; i++) {
        this.indexList.push(data[i].index)
      }
      console.log('索引', this.indexList)
    },
    _iconClick(res, data, index) {
      switch (res) {
        case '编辑':
          // this._editModal(true, data.id)
          break
        case '删除':
          this.getPage.records.splice(index, 1)
          break
        case '操作日志':
          // this._record(data.id)
          break
      }
    },
    _deleteSample(data) {
      if (data.id === undefined) {
        return false
      } else {
        this._delete(data.id)
      }
    },

    _delete: async function(id) {
      const result = await meterSample.deleteById(id)
      if (result) {
        console.log(result)
      }
    },

    _selectAptitude(data) {
      console.log(data)
    },
    _handleRow(data) {
      this.currentRow = data.row
      this.currentIndex = data.rowIndex
    },
    channelInputLimit(e) {
      const key = e.key
      // 不允许输入'e'和'.'
      if (key === 'e' || key === '.') {
        e.returnValue = false
        return false
      }
      return true
    },
    /** *modal-footer */
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '保存':
          this._ok()
          break
      }
    },
    _hideLoading() {
      this.$refs.footerModal._hideLoading()
    },
    _resultChange(msg) {
      this.showModal = false
      this.$Message.success(msg)
      this.$emit('on-result-change')
      this._hideLoading()
    },
    _ok() {
      this.$refs.formObj.validate(valid => {
        if (valid) {
          const data = this.$serialize('MeterSendTestEdit')
          console.log(this.getPage.records)
          if (this.$string(this.id).isEmpty()) {
            // 添加
            if (this.formObj.projectLeaderId) {
              data.projectLeaderId = this.formObj.projectLeaderId
            }
            if (this.formObj.registrantId) {
              data.registrantId = this.formObj.registrantId
            }
            if (this.projectLeaderName.indexOf(data.projectLeader) === -1) {
              console.log('没有这个人')
              data.projectLeader = undefined
              data.projectLeaderId = undefined
            }
            console.log('saveData', data)
            this._save(data)
          } else {
            data.id = this.id
            if (this.formObj.projectLeaderId) {
              data.projectLeaderId = this.formObj.projectLeaderId
            }
            if (this.formObj.registrantId) {
              data.registrantId = this.formObj.registrantId
            }
            if (this.projectLeaderName.indexOf(data.projectLeader) === -1) {
              console.log('没有这个人')
              data.projectLeader = undefined
              data.projectLeaderId = undefined
            }
            this._edit(data)
          }
        } else {
          this.$Message.error('表单验证失败!')
        }
      })
    },
    _wayResult(msg, data) {
      switch (msg) {
        case 'select':
          this.formObj.clearingWay = data
          break
        case 'query':
          this.formObj.clearingWay = data
          this._wayQuery(data)
          break
      }
    },
    _wayQuery(query) {
      if (query === '') {
        this.clearingWayList = this.clearingWayListTemp
      } else {
        this.clearingWayList = this.clearingWayListTemp.filter(
          item => item.indexOf(query) > -1
        )
      }
    },
    _cancel() {
      this.showModal = false
    },
    _open(formObj) {
      this.$refs.autoInput._clear()
      this.edit = false
      this._getProjectList()
      this._getLeaderList()
      this.showBtn = true
      this.showModal = true
      this._hideLoading()
      if (this.$string(formObj).isEmpty()) {
        this.$refs.formObj.resetFields()
        this.getPage.records = []
        this.formObj.client = ''
        this.id = ''
        this.formObj.entrustDate = new Date()
        this.modalTitle = '收样新增'
      }
      this._getUser()
    },
    _openEdit(formObj) {
      this.edit = true
      console.log(formObj)
      this._getProjectList()
      this._getLeaderList()
      this.showBtn = false
      this.showModal = true
      this.$refs.formObj.resetFields()
      this._getUser()
      this.getPage.records = []
      this._hideLoading()
      this.id = ''
      this.modalTitle = '委托单编辑'
      this.id = formObj.id
      this.formObj = formObj
      this._showTime(formObj)
    },
    _getUser() {
      const user = Global.getUserInfo()
      this.formObj.receiver = user.realname
    },
    _getTestType: async function() {
      const result = await soilEntrust.testType('检验类别')
      console.log(result)
      if (result) {
        console.log('检验类别', result)
        this.typeoptions = result
      }
    },
    _showTime(formObj) {
      if (this.formObj.receiveTime === undefined) {
        this.formObj.receiveTime = ''
      } else {
        this.formObj.receiveTime = new Date(formObj.receiveTime)
      }
      if (this.formObj.registTime === undefined) {
        this.formObj.registTime = ''
      } else {
        this.formObj.registTime = new Date(formObj.registTime)
      }
    },
    _getList: async function() {
      const result = await meterEntrust.pageList()
      const list = []
      if (result) {
        for (let i = 0; i < result.length; i++) {
          list.push(result[i].cname)
        }
        this.customerData = list
      }
    },
    _getProjectList: async function() {
      const result = await soilEntrust.testType('项目名称')
      const projectlist = []
      if (result) {
        for (let i = 0; i < result.length; i++) {
          projectlist.push(result[i].name)
        }
        this.projectData = projectlist
      }
    },
    _getLeaderList: async function() {
      const result = await soilSample.getUserList()
      if (result) {
        this.projectLeaderData = result.records
        for (let i = 0; i < result.records.length; i++) {
          this.projectLeaderName.push(result.records[i].realname)
        }
      }
    },
    _getQueryList: async function(data) {
      const result = await meterEntrust.pageQueryList(data)
      const queryList = []
      if (result) {
        for (let i = 0; i < result.length; i++) {
          queryList.push(result[i].cname)
        }
        this.customerData = queryList
        console.log('委托商', result)
      }
    },
    _queryUserList: async function(query) {
      if (query.realname === '') {
        this.$forceUpdate()
        this.formObj.projectLeader = ''
      }
      const result = await soilSample.queryUserList(query)
      if (result) {
        this.projectLeaderData = result.records
      }
    },
    _getProjectQueryList: async function(data) {
      const queryData = {}
      queryData.type = '项目名称'
      queryData.name = data
      const result = await soilEntrust.projectQueryList(queryData)
      const queryList = []
      if (result) {
        for (let i = 0; i < result.length; i++) {
          queryList.push(result[i].name)
        }
        this.projectData = queryList
        console.log('项目名称', result)
      }
    },
    _save: async function(data) {
      const result = await soilEntrust.aloneSampleAdd(data)
      if (result) {
        this._resultChange('添加成功!')
      } else {
        setTimeout(() => {
          this._hideLoading()
        }, 500)
      }
    },
    _edit: async function(data) {
      this._hideLoading()
      const result = await soilEntrust.aloneSampleEdit(data)
      if (result) {
        this._resultChange('编辑成功!')
      }
    },
    _sampleEdit: async function(data) {
      this._hideLoading()
      const result = await soilEntrust.editDTO(data)
      if (result) {
        this.$Message.success('编辑成功')
      }
    },
    _visibleChange(data) {
      this.$forceUpdate()
      console.log('清空')
      this.formObj.client = ''
      this.formObj = {}
    }
  }
}
</script>
<style>
.vxe-table--tooltip-wrapper {
  z-index: 2147483647 !important;
}
</style>
